{ This unit demonstrates basic features of the TDataSetPrint component.
  All extra data handling is designed for BIOLIFE table from DBDEMOS database
  that comes with Borland Delphi.
  It comes on a freeware basics "AS IS" so you may or may not use it on
  your own risk (see the readme file in the package). }

unit DSPSM; {- Designed for TDataSetPrint v1.23 } 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, DSprint, StdCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DataSetPrint1: TDataSetPrint;
    PreviewBtn: TButton;
    PreviewWithVRowsBtn: TButton;
    SimplePrintBtn: TButton;
    PrintWithExtraRowsBtn: TButton;
    PrintVlinesCB: TCheckBox;
    PrintHLinesCB: TCheckBox;
    NPagesToFit: TMaskEdit;
    Label1: TLabel;
    procedure PreviewBtnClick(Sender: TObject);
    procedure PreviewWithVRowsBtnClick(Sender: TObject);
    procedure SimplePrintBtnClick(Sender: TObject);
    procedure PrintWithExtraRowsBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PrintVlinesCBClick(Sender: TObject);
    procedure PrintHLinesCBClick(Sender: TObject);
    procedure DataSetPrint1BeforePrint(Sender: TObject);
  private
    { Private declarations }
    ExtraRows: boolean;
  public
    { Public declarations }
    procedure PreviewDSP;
    procedure PrintDSP;    
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PreviewDSP;
begin
  DataSetPrint1.NPagesToFit:= StrToIntDef(NPagesToFit.Text, 0);
  DataSetPrint1.Preview;
end;

procedure TForm1.PreviewBtnClick(Sender: TObject);
begin
  ExtraRows:= False;
  PreviewDSP;
end;

procedure TForm1.PreviewWithVRowsBtnClick(Sender: TObject);
begin
  ExtraRows:= True;
  PreviewDSP;
end;

procedure TForm1.PrintDSP;
begin
  DataSetPrint1.NPagesToFit:= StrToIntDef(NPagesToFit.Text, 0);
  DataSetPrint1.Print;
end;

procedure TForm1.SimplePrintBtnClick(Sender: TObject);
begin
  ExtraRows:= False;
  PrintDSP;
end;

procedure TForm1.PrintWithExtraRowsBtnClick(Sender: TObject);
begin
  ExtraRows:= True;
  PrintDSP;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PrintVLinesCB.Checked:= (ddoVertGridLines in DataSetPrint1.rpDataOptions);
  PrintHLinesCB.Checked:= (ddoHorzGridLines in DataSetPrint1.rpDataOptions);
end;

procedure TForm1.PrintVlinesCBClick(Sender: TObject);
begin
  if PrintVlinesCB.Checked then
    DataSetPrint1.rpDataOptions:= DataSetPrint1.rpDataOptions + [ddoVertGridLines]
  else
    DataSetPrint1.rpDataOptions:= DataSetPrint1.rpDataOptions - [ddoVertGridLines];
end;

procedure TForm1.PrintHLinesCBClick(Sender: TObject);
begin
  if PrintHlinesCB.Checked then
    DataSetPrint1.rpDataOptions:= DataSetPrint1.rpDataOptions + [ddoHorzGridLines]
  else
    DataSetPrint1.rpDataOptions:= DataSetPrint1.rpDataOptions - [ddoHorzGridLines];  
end;

procedure TForm1.DataSetPrint1BeforePrint(Sender: TObject);
var
  ColIdx: integer;
begin
  if not ExtraRows then
    Exit;

  with DataSetPrint1.ExtraGridRows do
  begin
    RowCount:= 2;

    Cells[0, 0]:= 'Totals:';
    Cells[0, 1]:= EmptyStr;

    for ColIdx:= 1 to ColCount-1 do
    begin
      Cells[ColIdx, 0]:= 'Totals header '+IntToStr(ColIdx);
      Cells[ColIdx, 1]:= IntToStr(ColIdx * 2);
    end; { for }
  end; { with }
end;

end.
